﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace TestApp5
{
    public partial class RadTimeBarAndChart : UserControl
    {
        public RadTimeBarAndChart()
        {
            this.DataContext = this;

            InitializeComponent();
        }

        public double Step
        {
            get
            {
                return TimeSpan.FromHours(1).TotalDays;
            }
        }

        public double MinValue
        {
            get
            {
                return timeBar1.PeriodStart.ToOADate();
            }
        }

        public double MaxValue
        {
            get
            {
                return timeBar1.PeriodEnd.ToOADate();
            }
        }

        public List<Item> Items
        {
            get
            {
                List<Item> items = new List<Item>();
                Random r = new Random();

                for (DateTime date = timeBar1.PeriodStart; date <= timeBar1.PeriodEnd; date = date.AddHours(1))
                {
                    items.Add(new Item() { VALORE = r.Next(0, 10), TimeStamp = date });
                }

                return items;
            }
        }
    }

    public class Item : INotifyPropertyChanged
    {
        private int valore;
        private DateTime timeStamp;

        public event PropertyChangedEventHandler PropertyChanged;

        public int VALORE
        {
            get
            {
                return valore;
            }
            set
            {
                valore = value;
                this.OnPropertyChanged("VALORE");
            }
        }

        public DateTime TimeStamp
        {
            get
            {
                return timeStamp;
            }
            set
            {
                timeStamp = value;
                this.OnPropertyChanged("TimeStamp");
            }
        }

        public void OnPropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
